
#define USEOLDKEY   NULL
#define USEOLDBASE  NULL

class Registry {
  public:
    Registry(HKEY basekey = NULL);
    ~Registry();

    // retrieval methods
    char *readString(char *label, char *key = USEOLDKEY, HKEY base = USEOLDBASE);
    void readStringIndirect(char *dest, int length, char *label,
	char *key = USEOLDKEY, HKEY base = USEOLDBASE);
    int readInteger(char *label, char *key = USEOLDKEY, HKEY base = USEOLDBASE);
    void readIntegerIndirect(int *dest, char *label, char *key = USEOLDKEY,
	HKEY base = USEOLDBASE);
    void readStructure(void *structure, int length, char *key = USEOLDKEY,
	HKEY base = USEOLDBASE);

    // writing methods
    void writeString(char *string, char *label, char *key = USEOLDKEY,
	HKEY base = USEOLDBASE);
    void writeInteger(int num, char *label, char *key = USEOLDKEY,
	HKEY base = USEOLDBASE);
    void writeStructure(void *structure, int length, char *key = USEOLDKEY,
	HKEY base = USEOLDBASE);

    // absolute and relative pathing
    void ChangeKey(char *keyName, HKEY hBaseKey);
    void ChangeKeyRelative(char *relKeyName);

    // determining what the error is
    inline long getError() const {return errorMessage;}

  private:
    // private methods
    void setKey(char *keyName, HKEY hBaseKey);

    // private variables
    HKEY hCurBase;
    HKEY hCurKey;
    char *szCurKey;
    long errorMessage;
};

