; =========================================================               
; CSXINPUT.INC: This file contains the includes needed for the
; Atari DSP implementation of CSX Synthesis. It should be
; included in each DAS file needed. This file contains those
; Addresses that must be known to the 68K code and the DSP only.
; =========================================================
; Copyright, 1995 Atari Corporation.
; Written for Atari by Highlight Software Solutions.
; =========================================================
; =========================================================
.DATA
.QPHRASE
	CSXINSIZE       .EQU            1024     ; size in 16 bit words
						; of the input audio buffer.
	CSXINHSIZE	.EQU		(CSXINSIZE/2)
						; 1/2 way pt of buffer
						; used to start any new
						; sound track
;       Input Audio Buffer Definition

CSXIN_START::
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 256 bytes

	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 512 bytes

	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 768 bytes

	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 1K bytes
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 256 bytes

	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 512 bytes

	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 768 bytes

	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	dc.l	0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0	; 64 bytes/line
	; 2K bytes

CSXIN_HEAD::
	dc.l    CSXIN_START

CSXIN_TAIL::
	dc.l    CSXIN_START
; ==================================================================
; REGISTERS USED TO INITIALIZE MODE OF CSX IN USE
CSXSETCHAN::
	dc.l	0 		; default to stereo (zero), mono (non-zero)


; 68K Debug Registers
; -------------------
CSX68_1::
	dc.l	0
CSX68_2::
	dc.l	0
CSX68_3::
	dc.l	0
CSX68_4::
	dc.l	0







