#ifndef __CRECT_H
#define __CRECT_H
#include "cpoint.h"
#include "csize.h"
struct CRect : public RECT
{
  public:
    CRect() {}

    CRect(const RECT& r)
    {
      left = r.left;
      right = r.right;
      top = r.top;
      bottom = r.bottom;
    }
    CRect(int l, int t, int r, int b)
    {
      left = l;
      right = r;
      top = t;
      bottom = b;
    }
    CRect(const CPoint& tl, const CPoint& br)
    {
      left = tl.x;
      right = br.x;
      top = tl.y;
      bottom = br.y;
    }
    operator RECT()
    {
    #ifdef MS_GETS_A_CLUE
      return (RECT)(*this);
    #else
      RECT r;
      r.left = left;
      r.top = top;
      r.right= right;
      r.bottom = bottom;
      return r;
    #endif
    }
    operator RECT() const
    {
    #ifdef MS_GETS_A_CLUE
      return (RECT)(*this);
    #else
      RECT r;
      r.left = left;
      r.top = top;
      r.right= right;
      r.bottom = bottom;
      return r;
    #endif
    }
    int GetWidth() const
    {
      return right-left;
    }
    int GetHeight() const
    {
      return bottom-top;
    }
    int Contains(const CPoint& p) const
    {
      return PtInRect(this, *(POINT*)&p);
    }
    int Overlaps(const CRect& p) const
    {
      RECT o;
      return IntersectRect(&o, this, &p);
    }
    void SetSize(const CSize& s)
    {
      right = left+s.cx;
      bottom = top+s.cy;
    }
    void Move(const CPoint& d)
    {
      int w = GetWidth();
      int h = GetHeight();
      top = d.y;
      left = d.x;
      right = left+w;
      bottom = top+h;
    }
    CSize GetSize() const
    {
      return CSize(GetWidth(), GetHeight());
    }
};
#endif
