#ifndef __EXNAMES_H
#define __EXNAMES_H

char* Exname(unsigned long code);

#if defined(NDEBUG)

#define GENERIC_TRY
#define FALSE_GENERIC_CATCH(name)
#define VOID_GENERIC_CATCH(name)
#define ABORT_GENERIC_CATCH(name)

#else // NDEBUG not defined.

#define GENERIC_TRY try
#define FALSE_GENERIC_CATCH(name) \
  __except(EXCEPTION_EXECUTE_HANDLER)                                 \
  {                                                                   \
    char exbuf[64];                                                   \
    wsprintf(exbuf, "C-based Excode %s", Exname(GetExceptionCode())); \
    ::MessageBox(0, exbuf, name, MB_OK);                                \
    return FALSE;                                                     \
  }

#define VOID_GENERIC_CATCH(name) \
  __except(1)                                                         \
  {                                                                   \
    char exbuf[64];                                                   \
    wsprintf(exbuf, "C-based Excode %s", Exname(GetExceptionCode())); \
    ::MessageBox(0, exbuf, name, MB_OK);                                \
    return;                                                           \
  }
#define ABORT_GENERIC_CATCH(name) \
  __except( MessageBox(0, Exname(GetExceptionCode()), "Aborting " name, MB_OK) \
          , EXCEPTION_CONTINUE_SEARCH \
          ) \
  {                                                                   \
  }
#define ABEND_CATCH(name) ABORT_GENERIC_CATCH(name)

#endif // NDEBUG

#endif // NOT ALREADY INCLUDED
