/**************************************************************************/
/**************************************************************************/
/*
hconst.h: This file contains the constants used globally in the CSX analysis
code. All files should be rebuilt if changes are made here.
*/
/**************************************************************************/
/*
Copyright, 1995 Atari Corporation.
Written for Atari by Highlight Software Solutions.
*/
/**************************************************************************/

/********* DATA ORGANIZATION CONSTANTS ***********/
#define MAXIBLOCK	256 		/** Size of Maxiblock. Should be **/
					/** a multiple of the Miniblock. **/
#define	MINIBLOCK	32   		/** Size of Miniblock. Should go **/
					/** evenly into Maxiblock.       **/
#define	LENGTHMASK	0x01FF		/** Mask to put length into      **/
					/** the header word in CSX hdr.  **/
#define BEGINCOUNT 15			/** count of 1st packing entry   **/
					/** in word **/
#define MAXREADSIZE	256   		/** This is the maximum words to **/
					/** be read at a time. **/
					/** Used to set array size **/
#define CSXHEADER	0x0E00		/** CSX Packet defined header **/
					/** Must only use the bits not **/
					/** used by the LENGTHMASK **/
#define BITSPERWORD	16		/** Acknowledges 16 bits word size **/
#define TOOMANYBITS	17		/** Filter bits to eliminate **/
#define HIGHVALUEMASK	0xFFFF0000	/** Mask of Long word part of HLONG **/
#define	PREEMPOFF	1		/** pre-emphisis state offset in hdr **/
#define	SFOFF		2		/** scale factor offset in hdr **/
#define	RANDOFF		3		/** dither random number offset **/
#define WINFILTEROFF	4 		/** Offset of winning filter info **/
					/** in CSX header **/
#define FILTERSTATEOFF	8        	/** offset in header for filter **/
					/** states in CSX header. **/
#define MAXFILTERS	3		/** MAXIMUM FILTER DEPTH **/
					/** This assumes only 1 filter of **/
					/** each order **/
#define HMONO		1  		/** Value for Mono to be set at **/
					/** the top of the program **/
#define HSTEREO 	2  		/** Value for stereo to be set at **/
					/** the top of the program **/
#define	HCSXB		1		/** lossless CSXB compression **/
#define	HCSXC		2		/** lossy CSXC compression **/
