/*
 *	jagfilm.h
 *
 *	Atari Jaguar CinePak Film Data Structures
 *
 *	Copyright 1996 Atari Corp.
 *	Secret & Confidential
 */

 /*
  * ---	Defines -----------------------------------------------------------------
  */
#define FILM_ID	0x46494C4D
#define ADSC_ID	0x41445343

#define AUDIO_ID 0x41554458

#define CSXA_ID 0x43535841
 /*
  * ---	Data Structures ---------------------------------------------------------
  */    


typedef struct _frameHeader {
	long	id;
	long	size;
	long	version;
	long	reserved;
} FRAME;

typedef struct _frameDescriptionAtom {
	long	id;
	long	size;
	long	ctype;
	long	height;
	long	width;
} FDSC;

typedef struct _audioDescriptionAtom {
	long	id;
	long	size;
	long	dataDescription;
	long	sclkRate;
	long	audioDriftRate;
} ADSC;

typedef struct	_sampleTableAtom {
	long	id;
	long	size;
	long	timeUnits;
	long	count;
} STAB;

typedef struct _sampleTableArray {
	long	offset;
	long	size;
	long	start;
	long	duration;
} STAR;

typedef struct film {
	FRAME	frameHeader;
	FDSC	frameDescreptionAtom;
	ADSC	audioDescriptionAtom;
	STAB	sampleTableAtom;
} FILM;

