//  options.h
#ifndef __OPTIONS_H
#define __OPTIONS_H

#include "regkey.h"

struct OptionsData
{
  // presentation
  BOOL subtitles;
  BOOL voiceovers;
  BOOL zoom;  
  BOOL skipahead;
  BOOL entirepath;
  BOOL menubar;

  // subjects to minimize
  char password[51];
  BOOL minViolence;
  BOOL minSex;

  // sweat
  int difficultyLevel;

  int volume;
};

////////////////////////////////////////////////////////////////////////////////
//  GameOptions is encapsulated so we can hook it up to the registry
//  later or whatever...
class GameOptions
{
public:
  GameOptions();
  ~GameOptions(void);
  void SetRegSubKey(const string& sub);

  BOOL SubtitlesOn(void) {return od.subtitles;}
  void SetSubtitles(BOOL f) {od.subtitles=f;}
  BOOL VoiceoversOn(void) {return od.voiceovers;}
  void SetVoiceovers(BOOL f) {od.voiceovers=f;}
  BOOL ZoomOn(void) {return od.zoom;}
  void SetZoom(BOOL f) {od.zoom=f;}
  BOOL SkipAheadOn(void) {return od.skipahead;}
  void SetSkipAhead(BOOL f) {od.skipahead=f;}
  BOOL EntirepathOn(void) {return od.entirepath;}
  void SetEntirepath(BOOL f) {od.entirepath=f;}
  BOOL MenubarOn(void) {return od.menubar;}
  void SetMenubar(BOOL f) {od.menubar=f;}
  string GetPassword(void); 
  void SetPassword(string s);
  BOOL MinViolenceOn(void) {return od.minViolence;}
  void SetMinViolence(BOOL f) {od.minViolence=f;}
  BOOL MinSexOn(void) {return od.minSex;}
  void SetMinSex(BOOL f) {od.minSex=f;}
  int GetDifficultyLevel(void) {return od.difficultyLevel;}
  void SetDifficultyLevel(int n) {od.difficultyLevel=n;}
  void SetVolume(int n) { od.volume=n; }
  int GetVolume() const { return od.volume; }
  void CopyFromRegistry();
  // Can come from 
  const OptionsData& GetData() const { return od; }
  void SetData(const OptionsData& newd) { sourceReg = 0; od = newd; }
private:
  void CommitRegistry();
  BOOL sourceReg;
  OptionsData od;
  RegKey regkey;
  string keyName;
};

#endif