/*********************************************************************\

	RJM_AVI.CPP
	Written & Designed by Rudy Mathieu

\*********************************************************************/

#include <stdio.h>
#include "rav.h"

BOOL RAVreadsample(int h, PFrameSampleStr sample, PLONG bytesWritten)
{
	int err;
	*bytesWritten = 0;
	/* Header */ 
	err = _read(h,sample,sizeof(FrameSampleStr));
	if (err==-1) 
		return FALSE;
	*bytesWritten += err;
	/* Read Audio Sample */
	sample->audio = (PBYTE)sample + *bytesWritten;
	err = _read(h,sample->audio,sample->audioSize);
	if (err==-1) 
		return FALSE;
	*bytesWritten += err;
	/* Read Video sample */
	sample->video = (PBYTE)sample->audio + *bytesWritten;
	err = _read(h,sample->video,sample->videoSize);
	if (err==-1) 
		return FALSE;
	*bytesWritten += err;
	return TRUE;
}

BOOL RAVreadheader(int h, PFileInfoStr buffer)
{
	if (_read(h,buffer,sizeof(*buffer)) < 1)
	   return FALSE;

	return TRUE;
}

BOOL RAVappend(int h, LPVOID data, DWORD size)
{
   if (lseek(h,0,SEEK_END)==-1) 
   		return FALSE;
   if (_write(h,(char *)data,size)==-1) 
   		return FALSE;
   return TRUE;
}

BOOL RAVaddsample(int h, PFrameSampleStr sample)
{
   BOOL err;
   int c = (sample->audioSize+sample->videoSize) & 3;
   if (c)
	   sample->videoSize += 4-c;

   LPVOID audioBuffer = sample->audio;
   LPVOID videoBuffer = sample->video;
   sample->video = sample->audio = NULL;
   err  = RAVappend(h, sample, sizeof(*sample));
   err |= RAVappend(h, videoBuffer, sample->videoSize);
   err |= RAVappend(h, audioBuffer, sample->audioSize);
   return err;
}

BOOL RAVupdateheader(int h, PFileInfoStr rjm)
{
   if (lseek(h,0,SEEK_SET)==-1) 
   		return FALSE;

   if (_write(h,(char *)rjm,sizeof(*rjm))==-1) 
   		return FALSE;

   return TRUE;
}

void RAVavi2ravinfo(FileInfoStr *rjm,AVIFILEINFO *ms)
{
   rjm->fileID = AV_FILE_ID;
   rjm->version = AV_FILE_VERSION;
   rjm->imageWidth  = (WORD)ms->dwWidth;
   rjm->imageHeight = (WORD)ms->dwHeight;
   rjm->framerate   = (WORD)(ms->dwRate / ms->dwScale);
   rjm->totalframes = (DWORD)ms->dwLength;
}

char *RAVtimecode2text(char *sprintformat, DWORD tc)
{
   static char t[255];
   sprintf(t,sprintformat,
	       RAV_GET_HOUR(tc),
		   RAV_GET_MINUTE(tc),
		   RAV_GET_SECOND(tc),
		   RAV_GET_FRAME(tc));
   return t;
}

DWORD RAVframe2timecode(DWORD frame,DWORD framesPerSec)
{
   DWORD hh=0,mm=0,ss=0;
   DWORD samplePerMin  = framesPerSec * 60;
   DWORD samplePerHour = samplePerMin * 60;
   hh = frame / samplePerHour;
   frame -= (hh * samplePerHour);
   mm = frame / samplePerMin;
   frame -= (mm * samplePerMin);
   ss = frame / framesPerSec;
   frame -= (ss * framesPerSec);
   return  RAV_MAKE_TIMECODE(hh,mm,ss,frame + 1); /* Indexed by 1 */
}
