#include "fwl5.h"
#include "cdbox.h"
#include "navcontr.h"
#include "disks.h"
#include "resource.h"
#include "dlgitem.h"

BEGIN_COMMAND_TABLE(CDBox)
 BIND_COMMAND(CDBox, OnOK, IDC_CONTINUE)
 BIND_COMMAND(CDBox, OnQuit, IDC_QUIT)
END_COMMAND_TABLE();

int CDBox::RunModal(BaseWin* w)
{
  return Dialog::RunModal(w, IDD_CDBOX);
}

BOOL CDBox::OnCreate()
{
  DialogItem prompt(this, ID_CAPTION);

  string ncaption = "Insert The CD Labeled\n"
    + disks->GetCD(targetDrive).friendlyName
    + "\nand Press OK\rOr Press \"Quit Game\" if you prefer."
    ;
  prompt.SetTitle(ncaption);

  SelfCenter();
  return TRUE;
}

void CDBox::OnOK(int,int)
{
  //string keyname = "Software\\Atari\\GameFilm\\" + controller->GetRegKey();
  //RegKey key(HKEY_CURRENT_USER, keyname);
  //key.Open();
  if (disks->CheckPresence(targetDrive))
  {
    Terminate(IDC_CONTINUE);
  }
  else
  {
    //string friendly = disks->GetCD(targetDrive).friendlyName;
    //string msg = "CD should have volume name of " + friendly;
    string vol = disks->GetCD(targetDrive).volumeName;
    string msg = "CD should have volume name of " + vol;
    MessageBox(msg, "Please!", MB_OK + MB_ICONEXCLAMATION);
  }
#if 0
  disks.CheckPresence(targetDisk);
  DiskID diskID = controller->GetCDInfo(1);//key.GetValue("cvol1");
  string volID = diskID.volumeName;
  string arcFile = diskID.path;//key.GetValue("cmoo1");
  if (volID.length())
  {
    string cdrpath;
    string volname;
    DWORD volser;
    DWORD fsizemax;
    DWORD flags;
    string filesys;
    cdrpath.resize(128);
    volname.resize(128);
    filesys.resize(128);
    char* cp = strchr(arcFile.c_str(), '\\');
    strncpy((char*)cdrpath.c_str(), arcFile.c_str(), cp-arcFile.c_str()+1);
    cdrpath.c_str()[cp-arcFile.c_str()+1] = 0;
    if (GetVolumeInformation( cdrpath.c_str()
                            , (char*)volname.c_str()
                            , 128
                            , &volser
                            , &fsizemax
                            , &flags
                            , (char*)filesys.c_str()
                            , 128
                            )
       )
    {
      if (volname == volID)
      {
        Terminate(IDC_CONTINUE);
      }
      else
      {
        string msg = "CD should have volume name of " + volID;
        MessageBox(msg, "Please!", MB_OK + MB_ICONEXCLAMATION);
      }
    }
  }
#endif
}
void CDBox::OnQuit(int,int)
{
  Terminate(IDC_QUIT);
}
