#ifndef clcontex_h
#define clcontex_h
class ClipContext
{
public:
  int segIndex;
  int trackIndex;
  int passCount;
  CPNode* node;
  Film* clip;
  int hyperClicks;
  //BOOL segOn;
  //BOOL changed;
  //BOOL hyperGate;
  //BOOL shotGate;
  //BOOL isHyperSeg;
  //BOOL loop;
  int segOn:1;
  int changed:1;
  int hyperGate:1;
  int shotGate:1;
  int isHyperSeg:1;
  int loop:1;
  void ClipSegStart(CPNode* node_, Film* clip_)
  {
    clip = clip_;
    node = node_;
    segIndex = segCounter++;
    loop = node->data.film.type == CP_LOOP;
    shotGate = node->data.film.type == CP_SHOT;
    passCount = clip->GetLoopCount();
    if (loop)
    {
      trackIndex = 0;
    }
    else
    {
      trackIndex = (node->data.film.visits-1)%node->data.film.tracks;
    }
    assert(segIndex < (int)node->data.film.pTracks[trackIndex].segments);
    segOn = TRUE;
    isHyperSeg = FALSE;
    changed = TRUE;
  }
  void ClipSegEnd(CPNode* node_, Film* clip_)
  {
    node = node_;
    clip = clip_;
    segOn = FALSE;
    shotGate = FALSE;
    changed = TRUE;
  }
  void HyperSegStart(CPNode* node_, Film* clip_)
  {
    clip = clip_;
    node = node_;
    loop = FALSE;
    segOn = TRUE;
    isHyperSeg = TRUE;
    hyperClicks = 0;
    hyperGate = TRUE;
    trackIndex = 0;
    segIndex = 0;
    changed = TRUE;
  }
  void HyperSegEnd(CPNode* node_, Film* clip_)
  {
    segOn = FALSE;
    hyperGate = FALSE;
    changed = TRUE;
  }
  void ClipStart(CPNode* node_, Film* clip_)
  {
    segCounter = 0;
  }
  void ClipEnd(CPNode* node_, Film* clip_)
  {
  }
private:
  int segCounter;
};
#endif