#ifndef _SMARTFILE
#define _SMARTFILE

#include "windows.h"
#include "sptypes.h"
#include "histogram.h"
/* Setup timing information for all asynchronus ops */
void SFtaskinfo(DWORD millisec=100, int sleepspercycle=5);

#define BYTESLOADED() \
((dataend>=datastart)?(dataend-datastart):(dataend-datastart+buffersize))

class Smartfile
{
protected:
	//int 	status;				// Status mask
  struct statusBits
  {
    int bufferFull:1;
//    int bufferLock:1;
    int doneLoading:1;
    int readyToWork:1;
    int bufferWrapped:1;
    int dying:1;
  } status;

	HANDLE 	bufferSyncHandle;	// Handle for Mutex Sync
	
	DWORD   asyncID;			// Async thread id
	HANDLE  asyncHandle;		// Async thread handle

	char 	*buffer;			// Working buffer
	long 	buffersize;			// Buffer Size
	long	chunksize;			// File Chunk size
	long 	datastart,dataend;	// Valid Start/End Seqments

//	int 	bsize1,bsize2;		// /Broken data sizes

	HANDLE	fhandle;			// File handle

	long 	fileptr;	// Real file pointer
  long  dataRead; // for timing purposes
  DWORD openTicks; // for timing purposes
	Histogram readTime;

	BOOL Heartbeat(void);
	BOOL DataInside(long seg1,long seg2);
	void MoveAndWrapPointer(long &data, long size);

public:

	Smartfile();
	~Smartfile();
	
	BOOL SetupReadSize(long chsize);
	BOOL Setup(void *ptr, long size);

	BOOL Open(char *filename);
	BOOL Close(void);

	long HardSeek(long fp);
	long HardRead(void *ptr, long size);

	long Seek(long fp);
	long Read(void *ptr, long size);

  long BytesLoaded(void) {return BYTESLOADED(); }
	BOOL DataAvailable(DWORD size, DWORD &part1, DWORD &part2) const;
//	void Lock(void) {status.bufferLock=1;}//{ status |= BUFFER_LOCK; }
//	void Unlock(void) {status.bufferLock=0;}//{ status &= ~BUFFER_LOCK; }

	BOOL DoneLoading(void) {return status.doneLoading; }//{ return status & DONE_LOADING; }
	//BOOL ReadyToWork() {return status.readyToWork; }//{ return status & READY_TO_WORK; }
	BOOL ReadyToWork() const 
  {
    return fhandle != 0 && buffer != 0;
  }
	//BOOL Full(void) {return status.bufferFull;}//{ return status & BUFFER_FULL; }
	BOOL Full(void) //{return status.bufferFull;}//{ return status & BUFFER_FULL; }
  {
    return BytesLoaded()-buffersize > chunksize;
  }

	friend void AsyncLoader(PDWORD info);
private:
	Histogram slowReads;
};

#endif
