#include "fwl5.h"
#include "control.h"

int Window::fAppActive=0;   
//----------------------------------------------------------------------------
BOOL Window::Create()
{
  HWND h;
  DWORD dwStyle = WS_CLIPCHILDREN
           | style
           ;
            // anything you want, plus popup, caption, sysmenu.

  h = CreateWindowEx(exStyle
               , "L5"
               , title.c_str()
               , dwStyle 
               , outerRect.left // placement.left
               , outerRect.top //placement.top
               , outerRect.GetWidth()
               , outerRect.GetHeight()
               , par?(par->GetHWND()):0
               , (HMENU)(par?(id):0)
               , Application::FWGetAppInstance()
               , (char*)this
               );
  if (h)
  {
    SetHWND(h);
    SetWindowLong(h, 0, (LONG)this);
    return TRUE;
  }
  return FALSE;
}
//----------------------------------------------------------------------------
void Window::Close()
{
  PostMessage(GetHWND(),WM_CLOSE,0,0L);
}
//----------------------------------------------------------------------------
//void Window::SetMenu(const CMenu& menu)
//{
//	::SetMenu(GetHWND(), menu.hmenu);
//	((CMenu*)&menu)->host = GetHWND();
//}
//----------------------------------------------------------------------------
void Window::OnDestroy(void)
{
}

//----------------------------------------------------------------------------
void Window::_MeasureItem
  ( UINT //id
  , MEASUREITEMSTRUCT* //item
  )
{
}

//----------------------------------------------------------------------------
void Window::_DrawItem
  ( UINT /*id*/
  , DRAWITEMSTRUCT* item
  )
{
    if (item->CtlType == ODT_BUTTON)
    {
			Control* b = (Control*)GetWindowLong(item->hwndItem, GWL_USERDATA);
			b->DrawItem(item->hDC, item->itemState, item->rcItem);
    }
}

//----------------------------------------------------------------------------
int
  Window::_CompareItem
    ( UINT /*id*/
    , COMPAREITEMSTRUCT* item
    )
{
  return 0;
}

	void Window::_Paint(WPARAM, LPARAM)
	{
		PAINTSTRUCT ps;
		HDC h = BeginPaint(GetHWND(), &ps);
		OnPaint(CDC(h), ps.rcPaint);
		EndPaint(GetHWND(), &ps);
	}
void Window::_Destruction()
{
  OnDestroy();
  LONG chStyle = GetWindowLong(GetHWND(), GWL_STYLE);
  SetHWND(0);
  if (chStyle & WS_POPUP)
  {
    PostQuitMessage(0);
  }
}
//----------------------------------------------------------------------------
void Window::_Close()
{
	  if (QueryClose())
	  {
			Destroy();
		}
}
//----------------------------------------------------------------------------
BOOL Window::OtherMessage(UINT msg, WPARAM wparam, LPARAM lparam, LRESULT& res)
{
  return 0;
}
//----------------------------------------------------------------------------
// Window::handler
// The WNDPROC for "L5" windows.
LRESULT CALLBACK
  Window::handler
	 ( HWND hWnd
	 , UINT msg
	 , WPARAM wParam
	 , LPARAM lParam
	 )
{
  Window* t = (Window*)GetWindowLong(hWnd, 0);
  Window* c;
  switch (msg)
  {
  case WM_CREATE:
    c = static_cast<Window*>(((CREATESTRUCT*)lParam)->lpCreateParams);
    c->SetHWND(hWnd);
    if (c->OnCreate())
    {
      return 0;
    }
    c->SetHWND(0);
    return -1;
  case WM_CONTEXTMENU:
    if (t!=0 
      &&  t->OnContextMenu((HWND)wParam, CPoint(LOWORD(lParam), HIWORD(lParam)))
      )
    {
      return 0; // if processed (return value not significant).
    }
    break; // allow DefWindowProc
  case WM_SIZE:
    if (t!=0)
    {
      t->_Size(wParam, lParam);
      return 0;
    }
    break;
  case WM_MOVE:
    if (t!=0)
    {
      t->_Move(LOWORD(lParam), HIWORD(lParam));
      return 0;
    }
    break;
  case WM_GETMINMAXINFO:
    if (t!=0 && t->trackInfoSet)
    {
      *((LPMINMAXINFO)lParam) = t->trackInfo;
      return 0;
    }
    break;
    //case WM_ERASEBKGND:
    //  return t->_EraseBackground(wParam);
  case WM_COMMAND:
    // control is LPARAM.
    t->Execute(LOWORD(wParam), HIWORD(wParam));
    return 0;

  case WM_MEASUREITEM:
    t->_MeasureItem(wParam, (MEASUREITEMSTRUCT*)lParam);
    return TRUE;
  case WM_DRAWITEM:
    t->_DrawItem(wParam, (DRAWITEMSTRUCT*)lParam);
    return TRUE;
  case WM_COMPAREITEM:
    return t->_CompareItem(wParam, (COMPAREITEMSTRUCT*)lParam);
  case WM_LBUTTONDOWN:
    t->MouseDown(CPoint(LOWORD(lParam), HIWORD(lParam)), wParam);
    return 0;
  case WM_RBUTTONDOWN:
    t->MouseDown(CPoint(LOWORD(lParam), HIWORD(lParam)), wParam);
    return 0;
  case WM_LBUTTONDBLCLK:
  case WM_RBUTTONDBLCLK:
    return 0;
  case WM_LBUTTONUP:
  case WM_RBUTTONUP:
    if (t->MouseUp(CPoint(LOWORD(lParam), HIWORD(lParam)), wParam))
    {
      return 0;
    }
    break;
  case WM_MOUSEMOVE:
    t->MouseMove(CPoint(LOWORD(lParam), HIWORD(lParam)), wParam);
    return 0;
    //  case WM_PALETTECHANGED:
    //    if (hWnd == (HWND)wParam)
    //    {
    //      return 0;
    //    }
    //    // fall through.
    //  case WM_QUERYNEWPALETTE:
    //    {
    //      HDC h = GetDC(hWnd);
    //      Palette p = t->GetPalette();
    //      int rc = 0;
    //      if (p.Loaded())
    //      {
    //        HPALETTE hp = p.GetHPALETTE();
    //        if (hp)
    //        {
    //        #if 0
    //          HPALETTE xp = SelectPalette(h, hp, FALSE);
    //          rc = RealizePalette(h);
    //          SelectPalette(h, xp, FALSE);
    //        #else
    //          SelectPalette(h, hp, FALSE);
    //					rc = RealizePalette(h);
    //        #endif
    //        }
    //      }
    //      ReleaseDC(hWnd, h);
    //      ODF(("%d Realized %d colors", p.Loaded(), rc));
    //      if (rc)
    //      {
    //        InvalidateRect(hWnd, 0, TRUE);
    //        return TRUE;
    //      }
    //    }
    //    return FALSE;
  case WM_PAINT:
    t->_Paint(wParam, lParam);
    return 0;
  case WM_DESTROY:
    if (t) t->_Destruction();
    return 0;
  case WM_CLOSE:
    t->_Close();
    return 0;
  case WM_TIMER:
    t->_Timer();
    return 0;
  case WM_ACTIVATEAPP:
    //*** Keep track of whether or not the app is in the foreground
    fAppActive = (BOOL)wParam;
    break;
  case WM_KEYDOWN:
    t->Key(wParam, lParam);
    return 0;
  default:
    if (t)
    {
      long rv;
      if (t->OtherMessage(msg, wParam, lParam, rv))
      {
        return rv;
      }
    }
    break;
  }
  return DefWindowProc(hWnd, msg, wParam, lParam);
}

void Window::Seek(int ctl, int notify)
{
//	switch (notify)
//	{
//	case LBN_SELCHANGE:
//		{
//			HWND hCtl = GetDlgItem(GetHWND(), ctl);
//			int kItem = (int)SendMessage(hCtl, LB_GETCURSEL, 0, 0);
//			BoxItem* item = (BoxItem*)SendMessage(hCtl, LB_GETITEMDATA, kItem, 0);
//			if (item)
//			{
//				item->OnSelect();
//			}
//		}
//		break;
//	}
}

BOOL Window::OnCreate() { return FALSE; }
//----------------------------------------------------------------------------
BOOL Window::_Creation()
{
  return OnCreate();
}
//----------------------------------------------------------------------------
LRESULT Window::_EraseBackground(WPARAM wParam)
{
  return OnEraseBackground(CDC((HDC)wParam));
}
//----------------------------------------------------------------------------
LRESULT Window::_Timer()
{
  OnTimer();
  return 0;
}

//----------------------------------------------------------------------------
void Window::SetSizeTracking
  ( const CSize& minSize
  , const CSize& maxSize
  , const CPoint& maxedULC
  )
{
  trackInfoSet = TRUE;
  trackInfo.ptMaxSize.x = maxSize.cx;
  trackInfo.ptMaxSize.y = maxSize.cy;
  trackInfo.ptMinTrackSize.x = minSize.cx;
  trackInfo.ptMinTrackSize.y = minSize.cy;
  trackInfo.ptMaxTrackSize.x = maxSize.cx;
  trackInfo.ptMaxTrackSize.y = maxSize.cy;
  trackInfo.ptMaxPosition.x = maxedULC.x;
  trackInfo.ptMaxPosition.y = maxedULC.y;
}

//----------------------------------------------------------------------------
LRESULT Window::_Size(WPARAM wParam, LPARAM lParam)
{
  GetWindowRect(GetHWND(), &outerRect);
  OnSize(wParam, LOWORD(lParam), HIWORD(lParam));
  return 0;
}

void Window::_Move(int x, int y)
{
  GetWindowRect(GetHWND(), &outerRect);
  OnMove(x, y);
}
